This is the README file for the Caml Light toplevel system adapted for Atari
by Christian CARREZ, CNAM-PARIS, 29 December 1993.

Caml Light is a product from Inria, see the copyright.

To work with the system on atari, there are three possibilities:

1 Call from the camlight.prg program. This is an interactive multi windows 
  interface very similar to the MacIntosh Caml Light version. Just double
  click on camlight.prg icon. Some particularities will be explained below.
 
2 Call from a shell, like gulam. This is approximately like on Unix systems.
  Assuming the directory where the readme file is at top level of C: disk,
  type:
	c:\caml\camlrun.ttp c:\caml\tools\camltop -stdlib c:\caml\lib
  This will load and execute the interactive Caml Light system.
  Others tools are available in the tools directory. See the manual from Inria.

3 Direct call from Desktop, by double click on "camlrun.ttp". This will
  ask you some parameters. Just type:
	tools\camltop -stdlib lib
  This will load the interactive caml light system.

One particularity of the system on Atari in the last two calls: To interrupt 
a running caml program, press the Function 1 key. In the first call, 
there is a menu command to do that, as in the MacIntosh version.

WINDOW INTERFACE.

The window interface is a separate program, which call the camlrun.ttp 
program. When you click on the camlight.prg icon you load and run the 
interface, which then load and run camlrun.ttp, passing the right parameters.

When you click on the camlight.prg icon while holding down one of the 
shift key you prevent the interface to immediately load the compiler. 
It will do that only when you click the interrupt command of the menu. 
So you can change parameters for camlrun. In that case, when you quit
while camlrun is running, you go back to the interface, not to the desktop.
Note that "$D" in the names or parameters is replaced by the full path
of the directory which is current at the time of loading camlight.prg.

The "quit();;" command to caml will stop camlrun, not the interface, as
if camlight.prg had been loaded with the shift key down. You may then rerun
camlrun. Note that the interface buffers remain unchanged, while the
camlrun ones are cleared.

At the beginning of the session, two windows are openned, one for 
input and one for output. These windows can be resized or moved, 
but you can't close them. A third window can be opened or closed, which 
shows the history, i.e. the commands sent to caml.       

The caml program lines are typed in the input window, then sent to the 
history buffer, where caml takes them. When a line is given to caml, it is
sent to the output window. The output from camlrun goes to the output window.

The file menu contains commands to read or write files. 

The first group allows you to build a file from selected parts of the window 
contents. You may open a file for output, copy one or several parts of text 
from any text window, and  close it. The parts are defined by selecting 
text with the mouse, as for copying to the scrapboard.
 
The second group reads files or saves a complete buffer. 

While in the input or History window, the "Read File" command reads the 
file in the current window. If this one is the History window, the 
content of the file is added to the history as if it had been typed in. 
If it is the Input window, the content of the file replace the previous 
content of the Input window, which is lost.

While in the Output or History window, the "Save on file" command writes 
the content of the window buffer in a file. 

The third group of the file menu sends control functions to caml, to 
include, load source or load object into memory. See 4.2 in the Caml 
reference manual.  

In the CamlLight menu there are commands to show or hide windows, to 
retreive previous program lines from history, to interrupt a caml program, 
to finish the current garbage collect cycle and to define your preferences.

The window menu shows the active window.

Some menu functions have an associated ctrl-key binding. If an item has 
such a binding, it is noted in the menu with ^. 

This is a beta test version of the window interface. However, it seems 
that it already makes caml easier to work with. Graphic is not yet implemented. 

Christian CARREZ
Departement Informatique
CNAM
292 rue Saint Martin
F-75141 Paris Cedex 03
e-mail: carrez@cnam.cnam.fr
